PROGRAM NEWBMP2TXT; {v2.01}
USES CRT,DOS;

const
COLORS=30;

DSIPAL:STRING=

' '+CHR(39)+'`~'+CHR(39)+''+CHR(39)+''+CHR(39)+''+CHR(39)+'````-``",'+CHR(39)+':~='+CHR(39)+''+CHR(39)+''+CHR(39)+'/>'+CHR(39)+
CHR(39)+'+"'+CHR(39)+''+CHR(39)+',::~\`<`=```+``"--;=+`"`+"'+CHR(39)+'"*`""'+
'.::::!:!;!;`!!!!,i;!iIP/7!,;;;>b{,)J]a)/,;;;+bfF/DdPpD/P'+
'.::::!!!:!!!"!!!,;;RL(<}dRcttP,ii;\\ji)IT\fT,;;;\GS<AAq\(9'+
'_;;;;L;!;;;!=!!!,L;ZLLCCc2ZZctt,;;;b6SjjJ]bj9idb6d2dd';

colpal:array[1..colors,1..8] of byte=
                     ((0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,0,0,0,0,0,0,0),
                     (0,1,0,0,0,0,0,0),
                     (0,1,0,0,0,0,0,0),
                     (0,1,0,0,0,1,0,0),
                     (0,1,0,0,0,1,0,0),
                     (0,1,1,0,0,1,1,0),
                     (1,1,1,0,1,1,1,0),
                     (1,1,1,0,1,1,1,0),
                     (1,1,1,1,1,1,1,0),
                     (1,1,1,1,1,1,1,0),
                     (1,1,1,1,1,1,1,0),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1),
                     (1,1,1,1,1,1,1,1));
VAR
PALT:ARRAY[1..256] OF CHAR;
EMPTY:ARRAY[1..33000] OF BYTE;
LINE:ARRAY[1..4,1..640] OF BYTE;
PALLETE:ARRAY[1..256] OF BYTE;
MAXX,MAXX2,MAXY,TX,TY,TCOL:WORD;
FS:FILE;
FT:TEXT;
NAMES,NAMET,NAMEB:STRING[12];
TSTR:STRING[15];
I,J,N,M:INTEGER;
FOFFSET,FPOS,COL:LONGINT;
STROKA:STRING;
STY,B,BCOL:BYTE;

PROCEDURE OPENFILES;
BEGIN
{$I-}
ASSIGN (FS,NAMES);
RESET(FS,1);
{$I+}
IF IORESULT<>0 THEN BEGIN
                    WRITELN('訡  䠩: ',NAMES);
                    HALT;
                    END;

{$I-}
ASSIGN (FT,NAMET);
REWRITE(FT);
{RESET(FT);
{$I+}
IF IORESULT<>0 THEN BEGIN
                    WRITELN('訡 ᮧ ⥪⮢ 䠩: ',NAMET);
                    HALT;
                    END;
END;

PROCEDURE CLOSEFILES;
BEGIN
CLOSE(FS);
CLOSE(FT);
END;

function ReadChar:Char;     { }
var
  Ch,CH2: Char;
begin
  Ch := ReadKey;
  if Ch = #0 then begin
    CH2:=READKEY;
    end;
  ReadChar := Ch;
end;


PROCEDURE READBMPINFO;
BEGIN
BLOCKREAD(FS,TCOL,2);
IF TCOL<>$4D42 THEN BEGIN
                    WRITELN(' ',NAMES,'  BMP-ଠ !!!');
                    HALT;
                    END;
SEEK(FS,10);
BLOCKREAD(FS,FOFFSET,4);

SEEK(FS,$12);
BLOCKREAD(FS,MAXX,2);
MAXX2:=MAXX;
SEEK(FS,$16);
BLOCKREAD(FS,MAXY,2);
SEEK(FS,28);
BLOCKREAD(FS,TCOL,2);


IF TCOL<>8 THEN BEGIN
                  WRITELN(' '+NAMES+'  ᮤঠ      256 梥⮢!');
                  HALT;
                  END;
BLOCKREAD(FS,TCOL,2);
IF TCOL<>0 THEN BEGIN
                WRITELN(' ଠ ᨨ  䠩 '+NAMES+' ⮩ ᨥ  ন!');
                HALT;
                END;

IF MAXX>480 THEN BEGIN
                 WRITELN(' ࠭  480 ᥫ, ⮬   㤥 १!');
                 MAXX:=480;
                 END;
SEEK(FS,$36);
FOR I:=1 TO 256 DO BEGIN
BLOCKREAD(FS,COL,4);
PALLETE[I]:=COL DIV (16777216 DIV COLORS);
END;
END;

PROCEDURE READLINE(I:INTEGER);
BEGIN
N:=4;
FPOS:=((I-1)*4)+3;
IF FPOS+1>MAXY THEN BEGIN
                  N:=FPOS-MAXY;
                  FPOS:=MAXY;
                  END;
FPOS:=LONGINT((MAXY-FPOS-1)*MAXX2)+FOFFSET;
SEEK(FS,FPOS);
FOR N:=N DOWNTO 1 DO BEGIN
BLOCKREAD(FS,LINE[N],MAXX);
FOR M:=1 TO MAXX DO LINE[N,M]:=PALLETE[LINE[N,M]+1];
END;
END;

FUNCTION GETSTRING(POS:BYTE):STRING;
VAR
SI,SJ:INTEGER;
GSTMP:STRING[15];
BEGIN
GSTMP:='';
FOR SI:=1 TO 4 DO
FOR SJ:=1 TO 2 DO
IF colpal[LINE[SI,SJ+((POS-1)*2)]+1,(si-1)*2+sj-1]=0 THEN GSTMP:=GSTMP+' '
                       ELSE GSTMP:=GSTMP+'O';
GETSTRING:=GSTMP;
END;
FUNCTION GETWORD(POS:BYTE):WORD;
VAR
SI,SJ:INTEGER;
GWST,GWTMP:WORD;

BEGIN
GWST:=1;
GWTMP:=0;
FOR SI:=1 TO 4 DO
FOR SJ:=1 TO 2 DO
BEGIN
IF colpal[LINE[SI,SJ+((POS-1)*2)]+1,(si-1)*2+sj-1]<>0 THEN GWTMP:=GWTMP+GWST;
GWST:=GWST+GWST;
END;
GETWORD:=GWTMP;
END;

PROCEDURE PRINTTABL;
VAR
TY,TX:INTEGER;
BEGIN
FOR TY:=1 TO 23 DO
FOR TX:=1 TO 10 DO BEGIN
                   GOTOXY((TX-1)*6+19,TY);
                   WRITE((TY-1)*10+(TX-1)+32:3,'-',CHR((TY-1)*10+(TX-1)+32));
                   END;
END;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}

BEGIN
WRITELN;
WRITELN('BMP to ASCII convertor V2.01 beta (C) SERGEY KRUTYKO 1998');
WRITELN;
NAMES:=paramstr(1);
IF NAMES='' THEN BEGIN
                 WRITELN(' ᪠ ணࠬ: BMP2TXT SCREENFILE.BMP [TEXTFILE.TXT]');
                 HALT;
                 END;
FOR I:=1 TO LENGTH(NAMES) DO IF NAMES[I]='.' THEN NAMET:=COPY(NAMES,1,I-1)+'.TXT';

OPENFILES;
READBMPINFO;
WRITELN(': ',NAMES,'  ଠ: BMP 256 梥⮢');
WRITELN('ਭ ࠭ - ',MAXX,' ᥫ');
WRITELN(' ࠭ - ',MAXY,' ᥫ');
WRITELN(LENGTH(DSIPAL));
TX:=MAXX DIV 2;
TY:=MAXY DIV 4;

FOR I:=1 TO TY DO BEGIN
READLINE(I);
STROKA:='';
FOR J:=1 TO TX DO BEGIN
TSTR:=GETSTRING(J);
TCOL:=GETWORD(J);
IF TCOL=255 THEN BCOL:=BYTE('')
            ELSE BCOL:=BYTE(DSIPAL[TCOL+1]);

STROKA:=STROKA+CHR(BCOL);
END;
IF LENGTH(STROKA)>79 THEN WRITELN(COPY (STROKA,1,79))
                     ELSE WRITELN(STROKA);
WRITELN(FT,STROKA);
END;
CLOSEFILES;
END.
